# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct AdminTeamsApi <: SwaggerApi
    client::Swagger.Client
end

function _swaggerinternal_adminTeamsCreate(_api::AdminTeamsApi, team_domain::String, team_name::String; team_description=nothing, team_discoverability=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/admin.teams.create", ["slackAuth"])
    Swagger.set_param(_ctx.form, "team_domain", team_domain)  # type String
    Swagger.set_param(_ctx.form, "team_name", team_name)  # type String
    Swagger.set_param(_ctx.form, "team_description", team_description)  # type String
    Swagger.set_param(_ctx.form, "team_discoverability", team_discoverability)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Create an Enterprise team.
Param: team_domain::String (required)
Param: team_name::String (required)
Param: team_description::String
Param: team_discoverability::String
Return: Dict{String, Any}
"""
function adminTeamsCreate(_api::AdminTeamsApi, team_domain::String, team_name::String; team_description=nothing, team_discoverability=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_adminTeamsCreate(_api, team_domain, team_name; team_description=team_description, team_discoverability=team_discoverability, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function adminTeamsCreate(_api::AdminTeamsApi, response_stream::Channel, team_domain::String, team_name::String; team_description=nothing, team_discoverability=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_adminTeamsCreate(_api, team_domain, team_name; team_description=team_description, team_discoverability=team_discoverability, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_adminTeamsList(_api::AdminTeamsApi; limit=nothing, cursor=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/admin.teams.list", ["slackAuth"])
    Swagger.set_param(_ctx.query, "limit", limit)  # type Int32
    Swagger.set_param(_ctx.query, "cursor", cursor)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

List all teams on an Enterprise organization
Param: limit::Int32
Param: cursor::String
Return: Dict{String, Any}
"""
function adminTeamsList(_api::AdminTeamsApi; limit=nothing, cursor=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_adminTeamsList(_api; limit=limit, cursor=cursor, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function adminTeamsList(_api::AdminTeamsApi, response_stream::Channel; limit=nothing, cursor=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_adminTeamsList(_api; limit=limit, cursor=cursor, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

export adminTeamsCreate, adminTeamsList
