# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct CallsApi <: SwaggerApi
    client::Swagger.Client
end

function _swaggerinternal_callsAdd(_api::CallsApi, external_unique_id::String, join_url::String; external_display_id=nothing, desktop_app_join_url=nothing, date_start=nothing, title=nothing, created_by=nothing, users=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/calls.add", ["slackAuth"])
    Swagger.set_param(_ctx.form, "external_unique_id", external_unique_id)  # type String
    Swagger.set_param(_ctx.form, "external_display_id", external_display_id)  # type String
    Swagger.set_param(_ctx.form, "join_url", join_url)  # type String
    Swagger.set_param(_ctx.form, "desktop_app_join_url", desktop_app_join_url)  # type String
    Swagger.set_param(_ctx.form, "date_start", date_start)  # type Int32
    Swagger.set_param(_ctx.form, "title", title)  # type String
    Swagger.set_param(_ctx.form, "created_by", created_by)  # type String
    Swagger.set_param(_ctx.form, "users", users)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Registers a new Call.
Param: external_unique_id::String (required)
Param: join_url::String (required)
Param: external_display_id::String
Param: desktop_app_join_url::String
Param: date_start::Int32
Param: title::String
Param: created_by::String
Param: users::String
Return: Dict{String, Any}
"""
function callsAdd(_api::CallsApi, external_unique_id::String, join_url::String; external_display_id=nothing, desktop_app_join_url=nothing, date_start=nothing, title=nothing, created_by=nothing, users=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_callsAdd(_api, external_unique_id, join_url; external_display_id=external_display_id, desktop_app_join_url=desktop_app_join_url, date_start=date_start, title=title, created_by=created_by, users=users, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function callsAdd(_api::CallsApi, response_stream::Channel, external_unique_id::String, join_url::String; external_display_id=nothing, desktop_app_join_url=nothing, date_start=nothing, title=nothing, created_by=nothing, users=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_callsAdd(_api, external_unique_id, join_url; external_display_id=external_display_id, desktop_app_join_url=desktop_app_join_url, date_start=date_start, title=title, created_by=created_by, users=users, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_callsEnd(_api::CallsApi, id::String; duration=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/calls.end", ["slackAuth"])
    Swagger.set_param(_ctx.form, "id", id)  # type String
    Swagger.set_param(_ctx.form, "duration", duration)  # type Int32
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Ends a Call.
Param: id::String (required)
Param: duration::Int32
Return: Dict{String, Any}
"""
function callsEnd(_api::CallsApi, id::String; duration=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_callsEnd(_api, id; duration=duration, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function callsEnd(_api::CallsApi, response_stream::Channel, id::String; duration=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_callsEnd(_api, id; duration=duration, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_callsInfo(_api::CallsApi, id::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/calls.info", ["slackAuth"])
    Swagger.set_param(_ctx.query, "id", id)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Returns information about a Call.
Param: id::String (required)
Return: Dict{String, Any}
"""
function callsInfo(_api::CallsApi, id::String; _mediaType=nothing)
    _ctx = _swaggerinternal_callsInfo(_api, id; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function callsInfo(_api::CallsApi, response_stream::Channel, id::String; _mediaType=nothing)
    _ctx = _swaggerinternal_callsInfo(_api, id; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_callsParticipantsAdd(_api::CallsApi, id::String, users::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/calls.participants.add", ["slackAuth"])
    Swagger.set_param(_ctx.form, "id", id)  # type String
    Swagger.set_param(_ctx.form, "users", users)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Registers new participants added to a Call.
Param: id::String (required)
Param: users::String (required)
Return: Dict{String, Any}
"""
function callsParticipantsAdd(_api::CallsApi, id::String, users::String; _mediaType=nothing)
    _ctx = _swaggerinternal_callsParticipantsAdd(_api, id, users; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function callsParticipantsAdd(_api::CallsApi, response_stream::Channel, id::String, users::String; _mediaType=nothing)
    _ctx = _swaggerinternal_callsParticipantsAdd(_api, id, users; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_callsParticipantsRemove(_api::CallsApi, id::String, users::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/calls.participants.remove", ["slackAuth"])
    Swagger.set_param(_ctx.form, "id", id)  # type String
    Swagger.set_param(_ctx.form, "users", users)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Registers participants removed from a Call.
Param: id::String (required)
Param: users::String (required)
Return: Dict{String, Any}
"""
function callsParticipantsRemove(_api::CallsApi, id::String, users::String; _mediaType=nothing)
    _ctx = _swaggerinternal_callsParticipantsRemove(_api, id, users; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function callsParticipantsRemove(_api::CallsApi, response_stream::Channel, id::String, users::String; _mediaType=nothing)
    _ctx = _swaggerinternal_callsParticipantsRemove(_api, id, users; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_callsUpdate(_api::CallsApi, id::String; title=nothing, join_url=nothing, desktop_app_join_url=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/calls.update", ["slackAuth"])
    Swagger.set_param(_ctx.form, "id", id)  # type String
    Swagger.set_param(_ctx.form, "title", title)  # type String
    Swagger.set_param(_ctx.form, "join_url", join_url)  # type String
    Swagger.set_param(_ctx.form, "desktop_app_join_url", desktop_app_join_url)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Updates information about a Call.
Param: id::String (required)
Param: title::String
Param: join_url::String
Param: desktop_app_join_url::String
Return: Dict{String, Any}
"""
function callsUpdate(_api::CallsApi, id::String; title=nothing, join_url=nothing, desktop_app_join_url=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_callsUpdate(_api, id; title=title, join_url=join_url, desktop_app_join_url=desktop_app_join_url, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function callsUpdate(_api::CallsApi, response_stream::Channel, id::String; title=nothing, join_url=nothing, desktop_app_join_url=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_callsUpdate(_api, id; title=title, join_url=join_url, desktop_app_join_url=desktop_app_join_url, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

export callsAdd, callsEnd, callsInfo, callsParticipantsAdd, callsParticipantsRemove, callsUpdate
