# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct DndApi <: SwaggerApi
    client::Swagger.Client
end

function _swaggerinternal_dndEndDnd(_api::DndApi; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/dnd.endDnd", ["slackAuth"])
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Ends the current user's Do Not Disturb session immediately.
Return: Dict{String, Any}
"""
function dndEndDnd(_api::DndApi; _mediaType=nothing)
    _ctx = _swaggerinternal_dndEndDnd(_api; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function dndEndDnd(_api::DndApi, response_stream::Channel; _mediaType=nothing)
    _ctx = _swaggerinternal_dndEndDnd(_api; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_dndEndSnooze(_api::DndApi; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/dnd.endSnooze", ["slackAuth"])
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Ends the current user's snooze mode immediately.
Return: Dict{String, Any}
"""
function dndEndSnooze(_api::DndApi; _mediaType=nothing)
    _ctx = _swaggerinternal_dndEndSnooze(_api; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function dndEndSnooze(_api::DndApi, response_stream::Channel; _mediaType=nothing)
    _ctx = _swaggerinternal_dndEndSnooze(_api; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_dndInfo(_api::DndApi; user=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/dnd.info", ["slackAuth"])
    Swagger.set_param(_ctx.query, "user", user)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Retrieves a user's current Do Not Disturb status.
Param: user::String
Return: Dict{String, Any}
"""
function dndInfo(_api::DndApi; user=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_dndInfo(_api; user=user, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function dndInfo(_api::DndApi, response_stream::Channel; user=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_dndInfo(_api; user=user, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_dndSetSnooze(_api::DndApi, num_minutes::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/dnd.setSnooze", ["slackAuth"])
    Swagger.set_param(_ctx.form, "num_minutes", num_minutes)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Turns on Do Not Disturb mode for the current user, or changes its duration.
Param: num_minutes::String (required)
Return: Dict{String, Any}
"""
function dndSetSnooze(_api::DndApi, num_minutes::String; _mediaType=nothing)
    _ctx = _swaggerinternal_dndSetSnooze(_api, num_minutes; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function dndSetSnooze(_api::DndApi, response_stream::Channel, num_minutes::String; _mediaType=nothing)
    _ctx = _swaggerinternal_dndSetSnooze(_api, num_minutes; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_dndTeamInfo(_api::DndApi; users=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/dnd.teamInfo", ["slackAuth"])
    Swagger.set_param(_ctx.query, "users", users)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Retrieves the Do Not Disturb status for up to 50 users on a team.
Param: users::String
Return: Dict{String, Any}
"""
function dndTeamInfo(_api::DndApi; users=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_dndTeamInfo(_api; users=users, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function dndTeamInfo(_api::DndApi, response_stream::Channel; users=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_dndTeamInfo(_api; users=users, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

export dndEndDnd, dndEndSnooze, dndInfo, dndSetSnooze, dndTeamInfo
