# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct FilesApi <: SwaggerApi
    client::Swagger.Client
end

function _swaggerinternal_filesCommentsDelete(_api::FilesApi; file=nothing, id=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/files.comments.delete", ["slackAuth"])
    Swagger.set_param(_ctx.form, "file", file)  # type String
    Swagger.set_param(_ctx.form, "id", id)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Deletes an existing comment on a file.
Param: file::String
Param: id::String
Return: Dict{String, Any}
"""
function filesCommentsDelete(_api::FilesApi; file=nothing, id=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesCommentsDelete(_api; file=file, id=id, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesCommentsDelete(_api::FilesApi, response_stream::Channel; file=nothing, id=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesCommentsDelete(_api; file=file, id=id, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesDelete(_api::FilesApi; file=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/files.delete", ["slackAuth"])
    Swagger.set_param(_ctx.form, "file", file)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Deletes a file.
Param: file::String
Return: Dict{String, Any}
"""
function filesDelete(_api::FilesApi; file=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesDelete(_api; file=file, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesDelete(_api::FilesApi, response_stream::Channel; file=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesDelete(_api; file=file, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesInfo(_api::FilesApi; file=nothing, count=nothing, page=nothing, limit=nothing, cursor=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/files.info", ["slackAuth"])
    Swagger.set_param(_ctx.query, "file", file)  # type String
    Swagger.set_param(_ctx.query, "count", count)  # type String
    Swagger.set_param(_ctx.query, "page", page)  # type String
    Swagger.set_param(_ctx.query, "limit", limit)  # type Int32
    Swagger.set_param(_ctx.query, "cursor", cursor)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Gets information about a file.
Param: file::String
Param: count::String
Param: page::String
Param: limit::Int32
Param: cursor::String
Return: Dict{String, Any}
"""
function filesInfo(_api::FilesApi; file=nothing, count=nothing, page=nothing, limit=nothing, cursor=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesInfo(_api; file=file, count=count, page=page, limit=limit, cursor=cursor, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesInfo(_api::FilesApi, response_stream::Channel; file=nothing, count=nothing, page=nothing, limit=nothing, cursor=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesInfo(_api; file=file, count=count, page=page, limit=limit, cursor=cursor, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesList(_api::FilesApi; user=nothing, channel=nothing, ts_from=nothing, ts_to=nothing, types=nothing, count=nothing, page=nothing, show_files_hidden_by_limit=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/files.list", ["slackAuth"])
    Swagger.set_param(_ctx.query, "user", user)  # type String
    Swagger.set_param(_ctx.query, "channel", channel)  # type String
    Swagger.set_param(_ctx.query, "ts_from", ts_from)  # type Float32
    Swagger.set_param(_ctx.query, "ts_to", ts_to)  # type Float32
    Swagger.set_param(_ctx.query, "types", types)  # type String
    Swagger.set_param(_ctx.query, "count", count)  # type String
    Swagger.set_param(_ctx.query, "page", page)  # type String
    Swagger.set_param(_ctx.query, "show_files_hidden_by_limit", show_files_hidden_by_limit)  # type Bool
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

List for a team, in a channel, or from a user with applied filters.
Param: user::String
Param: channel::String
Param: ts_from::Float32
Param: ts_to::Float32
Param: types::String
Param: count::String
Param: page::String
Param: show_files_hidden_by_limit::Bool
Return: Dict{String, Any}
"""
function filesList(_api::FilesApi; user=nothing, channel=nothing, ts_from=nothing, ts_to=nothing, types=nothing, count=nothing, page=nothing, show_files_hidden_by_limit=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesList(_api; user=user, channel=channel, ts_from=ts_from, ts_to=ts_to, types=types, count=count, page=page, show_files_hidden_by_limit=show_files_hidden_by_limit, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesList(_api::FilesApi, response_stream::Channel; user=nothing, channel=nothing, ts_from=nothing, ts_to=nothing, types=nothing, count=nothing, page=nothing, show_files_hidden_by_limit=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesList(_api; user=user, channel=channel, ts_from=ts_from, ts_to=ts_to, types=types, count=count, page=page, show_files_hidden_by_limit=show_files_hidden_by_limit, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesRemoteAdd(_api::FilesApi; external_id=nothing, title=nothing, filetype=nothing, external_url=nothing, preview_image=nothing, indexable_file_contents=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/files.remote.add", ["slackAuth"])
    Swagger.set_param(_ctx.form, "external_id", external_id)  # type String
    Swagger.set_param(_ctx.form, "title", title)  # type String
    Swagger.set_param(_ctx.form, "filetype", filetype)  # type String
    Swagger.set_param(_ctx.form, "external_url", external_url)  # type String
    Swagger.set_param(_ctx.form, "preview_image", preview_image)  # type String
    Swagger.set_param(_ctx.form, "indexable_file_contents", indexable_file_contents)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Adds a file from a remote service
Param: external_id::String
Param: title::String
Param: filetype::String
Param: external_url::String
Param: preview_image::String
Param: indexable_file_contents::String
Return: Dict{String, Any}
"""
function filesRemoteAdd(_api::FilesApi; external_id=nothing, title=nothing, filetype=nothing, external_url=nothing, preview_image=nothing, indexable_file_contents=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteAdd(_api; external_id=external_id, title=title, filetype=filetype, external_url=external_url, preview_image=preview_image, indexable_file_contents=indexable_file_contents, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesRemoteAdd(_api::FilesApi, response_stream::Channel; external_id=nothing, title=nothing, filetype=nothing, external_url=nothing, preview_image=nothing, indexable_file_contents=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteAdd(_api; external_id=external_id, title=title, filetype=filetype, external_url=external_url, preview_image=preview_image, indexable_file_contents=indexable_file_contents, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesRemoteInfo(_api::FilesApi; file=nothing, external_id=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/files.remote.info", ["slackAuth"])
    Swagger.set_param(_ctx.query, "file", file)  # type String
    Swagger.set_param(_ctx.query, "external_id", external_id)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Retrieve information about a remote file added to Slack
Param: file::String
Param: external_id::String
Return: Dict{String, Any}
"""
function filesRemoteInfo(_api::FilesApi; file=nothing, external_id=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteInfo(_api; file=file, external_id=external_id, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesRemoteInfo(_api::FilesApi, response_stream::Channel; file=nothing, external_id=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteInfo(_api; file=file, external_id=external_id, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesRemoteList(_api::FilesApi; channel=nothing, ts_from=nothing, ts_to=nothing, limit=nothing, cursor=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/files.remote.list", ["slackAuth"])
    Swagger.set_param(_ctx.query, "channel", channel)  # type String
    Swagger.set_param(_ctx.query, "ts_from", ts_from)  # type Float32
    Swagger.set_param(_ctx.query, "ts_to", ts_to)  # type Float32
    Swagger.set_param(_ctx.query, "limit", limit)  # type Int32
    Swagger.set_param(_ctx.query, "cursor", cursor)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Retrieve information about a remote file added to Slack
Param: channel::String
Param: ts_from::Float32
Param: ts_to::Float32
Param: limit::Int32
Param: cursor::String
Return: Dict{String, Any}
"""
function filesRemoteList(_api::FilesApi; channel=nothing, ts_from=nothing, ts_to=nothing, limit=nothing, cursor=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteList(_api; channel=channel, ts_from=ts_from, ts_to=ts_to, limit=limit, cursor=cursor, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesRemoteList(_api::FilesApi, response_stream::Channel; channel=nothing, ts_from=nothing, ts_to=nothing, limit=nothing, cursor=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteList(_api; channel=channel, ts_from=ts_from, ts_to=ts_to, limit=limit, cursor=cursor, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesRemoteRemove(_api::FilesApi; file=nothing, external_id=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/files.remote.remove", ["slackAuth"])
    Swagger.set_param(_ctx.form, "file", file)  # type String
    Swagger.set_param(_ctx.form, "external_id", external_id)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Remove a remote file.
Param: file::String
Param: external_id::String
Return: Dict{String, Any}
"""
function filesRemoteRemove(_api::FilesApi; file=nothing, external_id=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteRemove(_api; file=file, external_id=external_id, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesRemoteRemove(_api::FilesApi, response_stream::Channel; file=nothing, external_id=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteRemove(_api; file=file, external_id=external_id, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesRemoteShare(_api::FilesApi; file=nothing, external_id=nothing, channels=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/files.remote.share", ["slackAuth"])
    Swagger.set_param(_ctx.query, "file", file)  # type String
    Swagger.set_param(_ctx.query, "external_id", external_id)  # type String
    Swagger.set_param(_ctx.query, "channels", channels)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Share a remote file into a channel.
Param: file::String
Param: external_id::String
Param: channels::String
Return: Dict{String, Any}
"""
function filesRemoteShare(_api::FilesApi; file=nothing, external_id=nothing, channels=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteShare(_api; file=file, external_id=external_id, channels=channels, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesRemoteShare(_api::FilesApi, response_stream::Channel; file=nothing, external_id=nothing, channels=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteShare(_api; file=file, external_id=external_id, channels=channels, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesRemoteUpdate(_api::FilesApi; file=nothing, external_id=nothing, title=nothing, filetype=nothing, external_url=nothing, preview_image=nothing, indexable_file_contents=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/files.remote.update", ["slackAuth"])
    Swagger.set_param(_ctx.form, "file", file)  # type String
    Swagger.set_param(_ctx.form, "external_id", external_id)  # type String
    Swagger.set_param(_ctx.form, "title", title)  # type String
    Swagger.set_param(_ctx.form, "filetype", filetype)  # type String
    Swagger.set_param(_ctx.form, "external_url", external_url)  # type String
    Swagger.set_param(_ctx.form, "preview_image", preview_image)  # type String
    Swagger.set_param(_ctx.form, "indexable_file_contents", indexable_file_contents)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Updates an existing remote file.
Param: file::String
Param: external_id::String
Param: title::String
Param: filetype::String
Param: external_url::String
Param: preview_image::String
Param: indexable_file_contents::String
Return: Dict{String, Any}
"""
function filesRemoteUpdate(_api::FilesApi; file=nothing, external_id=nothing, title=nothing, filetype=nothing, external_url=nothing, preview_image=nothing, indexable_file_contents=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteUpdate(_api; file=file, external_id=external_id, title=title, filetype=filetype, external_url=external_url, preview_image=preview_image, indexable_file_contents=indexable_file_contents, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesRemoteUpdate(_api::FilesApi, response_stream::Channel; file=nothing, external_id=nothing, title=nothing, filetype=nothing, external_url=nothing, preview_image=nothing, indexable_file_contents=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRemoteUpdate(_api; file=file, external_id=external_id, title=title, filetype=filetype, external_url=external_url, preview_image=preview_image, indexable_file_contents=indexable_file_contents, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesRevokePublicURL(_api::FilesApi; file=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/files.revokePublicURL", ["slackAuth"])
    Swagger.set_param(_ctx.form, "file", file)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Revokes public/external sharing access for a file
Param: file::String
Return: Dict{String, Any}
"""
function filesRevokePublicURL(_api::FilesApi; file=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRevokePublicURL(_api; file=file, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesRevokePublicURL(_api::FilesApi, response_stream::Channel; file=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesRevokePublicURL(_api; file=file, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesSharedPublicURL(_api::FilesApi; file=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/files.sharedPublicURL", ["slackAuth"])
    Swagger.set_param(_ctx.form, "file", file)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Enables a file for public/external sharing.
Param: file::String
Return: Dict{String, Any}
"""
function filesSharedPublicURL(_api::FilesApi; file=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesSharedPublicURL(_api; file=file, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesSharedPublicURL(_api::FilesApi, response_stream::Channel; file=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesSharedPublicURL(_api; file=file, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_filesUpload(_api::FilesApi; file=nothing, content=nothing, filetype=nothing, filename=nothing, title=nothing, initial_comment=nothing, channels=nothing, thread_ts=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/files.upload", ["slackAuth"])
    Swagger.set_param(_ctx.form, "file", file)  # type String
    Swagger.set_param(_ctx.form, "content", content)  # type String
    Swagger.set_param(_ctx.form, "filetype", filetype)  # type String
    Swagger.set_param(_ctx.form, "filename", filename)  # type String
    Swagger.set_param(_ctx.form, "title", title)  # type String
    Swagger.set_param(_ctx.form, "initial_comment", initial_comment)  # type String
    Swagger.set_param(_ctx.form, "channels", channels)  # type String
    Swagger.set_param(_ctx.form, "thread_ts", thread_ts)  # type Float32
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Uploads or creates a file.
Param: file::String
Param: content::String
Param: filetype::String
Param: filename::String
Param: title::String
Param: initial_comment::String
Param: channels::String
Param: thread_ts::Float32
Return: Dict{String, Any}
"""
function filesUpload(_api::FilesApi; file=nothing, content=nothing, filetype=nothing, filename=nothing, title=nothing, initial_comment=nothing, channels=nothing, thread_ts=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesUpload(_api; file=file, content=content, filetype=filetype, filename=filename, title=title, initial_comment=initial_comment, channels=channels, thread_ts=thread_ts, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function filesUpload(_api::FilesApi, response_stream::Channel; file=nothing, content=nothing, filetype=nothing, filename=nothing, title=nothing, initial_comment=nothing, channels=nothing, thread_ts=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_filesUpload(_api; file=file, content=content, filetype=filetype, filename=filename, title=title, initial_comment=initial_comment, channels=channels, thread_ts=thread_ts, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

export filesCommentsDelete, filesDelete, filesInfo, filesList, filesRemoteAdd, filesRemoteInfo, filesRemoteList, filesRemoteRemove, filesRemoteShare, filesRemoteUpdate, filesRevokePublicURL, filesSharedPublicURL, filesUpload
