# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct OauthApi <: SwaggerApi
    client::Swagger.Client
end

function _swaggerinternal_oauthAccess(_api::OauthApi; client_id=nothing, client_secret=nothing, code=nothing, redirect_uri=nothing, single_channel=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/oauth.access", ["slackAuth"])
    Swagger.set_param(_ctx.query, "client_id", client_id)  # type String
    Swagger.set_param(_ctx.query, "client_secret", client_secret)  # type String
    Swagger.set_param(_ctx.query, "code", code)  # type String
    Swagger.set_param(_ctx.query, "redirect_uri", redirect_uri)  # type String
    Swagger.set_param(_ctx.query, "single_channel", single_channel)  # type Bool
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Exchanges a temporary OAuth verifier code for an access token.
Param: client_id::String
Param: client_secret::String
Param: code::String
Param: redirect_uri::String
Param: single_channel::Bool
Return: Dict{String, Any}
"""
function oauthAccess(_api::OauthApi; client_id=nothing, client_secret=nothing, code=nothing, redirect_uri=nothing, single_channel=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_oauthAccess(_api; client_id=client_id, client_secret=client_secret, code=code, redirect_uri=redirect_uri, single_channel=single_channel, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function oauthAccess(_api::OauthApi, response_stream::Channel; client_id=nothing, client_secret=nothing, code=nothing, redirect_uri=nothing, single_channel=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_oauthAccess(_api; client_id=client_id, client_secret=client_secret, code=code, redirect_uri=redirect_uri, single_channel=single_channel, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_oauthToken(_api::OauthApi; client_id=nothing, client_secret=nothing, code=nothing, redirect_uri=nothing, single_channel=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/oauth.token", ["slackAuth"])
    Swagger.set_param(_ctx.query, "client_id", client_id)  # type String
    Swagger.set_param(_ctx.query, "client_secret", client_secret)  # type String
    Swagger.set_param(_ctx.query, "code", code)  # type String
    Swagger.set_param(_ctx.query, "redirect_uri", redirect_uri)  # type String
    Swagger.set_param(_ctx.query, "single_channel", single_channel)  # type Bool
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Exchanges a temporary OAuth verifier code for a workspace token.
Param: client_id::String
Param: client_secret::String
Param: code::String
Param: redirect_uri::String
Param: single_channel::Bool
Return: Dict{String, Any}
"""
function oauthToken(_api::OauthApi; client_id=nothing, client_secret=nothing, code=nothing, redirect_uri=nothing, single_channel=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_oauthToken(_api; client_id=client_id, client_secret=client_secret, code=code, redirect_uri=redirect_uri, single_channel=single_channel, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function oauthToken(_api::OauthApi, response_stream::Channel; client_id=nothing, client_secret=nothing, code=nothing, redirect_uri=nothing, single_channel=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_oauthToken(_api; client_id=client_id, client_secret=client_secret, code=code, redirect_uri=redirect_uri, single_channel=single_channel, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_oauthV2Access(_api::OauthApi, code::String; client_id=nothing, client_secret=nothing, redirect_uri=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/oauth.v2.access", ["slackAuth"])
    Swagger.set_param(_ctx.query, "client_id", client_id)  # type String
    Swagger.set_param(_ctx.query, "client_secret", client_secret)  # type String
    Swagger.set_param(_ctx.query, "code", code)  # type String
    Swagger.set_param(_ctx.query, "redirect_uri", redirect_uri)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Exchanges a temporary OAuth verifier code for an access token.
Param: code::String (required)
Param: client_id::String
Param: client_secret::String
Param: redirect_uri::String
Return: Dict{String, Any}
"""
function oauthV2Access(_api::OauthApi, code::String; client_id=nothing, client_secret=nothing, redirect_uri=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_oauthV2Access(_api, code; client_id=client_id, client_secret=client_secret, redirect_uri=redirect_uri, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function oauthV2Access(_api::OauthApi, response_stream::Channel, code::String; client_id=nothing, client_secret=nothing, redirect_uri=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_oauthV2Access(_api, code; client_id=client_id, client_secret=client_secret, redirect_uri=redirect_uri, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

export oauthAccess, oauthToken, oauthV2Access
