# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct PinsApi <: SwaggerApi
    client::Swagger.Client
end

function _swaggerinternal_pinsAdd(_api::PinsApi, channel::String; timestamp=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/pins.add", ["slackAuth"])
    Swagger.set_param(_ctx.form, "channel", channel)  # type String
    Swagger.set_param(_ctx.form, "timestamp", timestamp)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Pins an item to a channel.
Param: channel::String (required)
Param: timestamp::String
Return: Dict{String, Any}
"""
function pinsAdd(_api::PinsApi, channel::String; timestamp=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_pinsAdd(_api, channel; timestamp=timestamp, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function pinsAdd(_api::PinsApi, response_stream::Channel, channel::String; timestamp=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_pinsAdd(_api, channel; timestamp=timestamp, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_pinsList(_api::PinsApi, channel::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Any, "/pins.list", ["slackAuth"])
    Swagger.set_param(_ctx.query, "channel", channel)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

Lists items pinned to a channel.
Param: channel::String (required)
Return: Any
"""
function pinsList(_api::PinsApi, channel::String; _mediaType=nothing)
    _ctx = _swaggerinternal_pinsList(_api, channel; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function pinsList(_api::PinsApi, response_stream::Channel, channel::String; _mediaType=nothing)
    _ctx = _swaggerinternal_pinsList(_api, channel; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_pinsRemove(_api::PinsApi, channel::String; timestamp=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/pins.remove", ["slackAuth"])
    Swagger.set_param(_ctx.form, "channel", channel)  # type String
    Swagger.set_param(_ctx.form, "timestamp", timestamp)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Un-pins an item from a channel.
Param: channel::String (required)
Param: timestamp::String
Return: Dict{String, Any}
"""
function pinsRemove(_api::PinsApi, channel::String; timestamp=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_pinsRemove(_api, channel; timestamp=timestamp, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function pinsRemove(_api::PinsApi, response_stream::Channel, channel::String; timestamp=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_pinsRemove(_api, channel; timestamp=timestamp, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

export pinsAdd, pinsList, pinsRemove
