# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct UsergroupsApi <: SwaggerApi
    client::Swagger.Client
end

function _swaggerinternal_usergroupsCreate(_api::UsergroupsApi, name::String; channels=nothing, description=nothing, handle=nothing, include_count=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/usergroups.create", ["slackAuth"])
    Swagger.set_param(_ctx.form, "channels", channels)  # type String
    Swagger.set_param(_ctx.form, "description", description)  # type String
    Swagger.set_param(_ctx.form, "handle", handle)  # type String
    Swagger.set_param(_ctx.form, "include_count", include_count)  # type Bool
    Swagger.set_param(_ctx.form, "name", name)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Create a User Group
Param: name::String (required)
Param: channels::String
Param: description::String
Param: handle::String
Param: include_count::Bool
Return: Dict{String, Any}
"""
function usergroupsCreate(_api::UsergroupsApi, name::String; channels=nothing, description=nothing, handle=nothing, include_count=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsCreate(_api, name; channels=channels, description=description, handle=handle, include_count=include_count, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function usergroupsCreate(_api::UsergroupsApi, response_stream::Channel, name::String; channels=nothing, description=nothing, handle=nothing, include_count=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsCreate(_api, name; channels=channels, description=description, handle=handle, include_count=include_count, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_usergroupsDisable(_api::UsergroupsApi, usergroup::String; include_count=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/usergroups.disable", ["slackAuth"])
    Swagger.set_param(_ctx.form, "include_count", include_count)  # type Bool
    Swagger.set_param(_ctx.form, "usergroup", usergroup)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Disable an existing User Group
Param: usergroup::String (required)
Param: include_count::Bool
Return: Dict{String, Any}
"""
function usergroupsDisable(_api::UsergroupsApi, usergroup::String; include_count=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsDisable(_api, usergroup; include_count=include_count, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function usergroupsDisable(_api::UsergroupsApi, response_stream::Channel, usergroup::String; include_count=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsDisable(_api, usergroup; include_count=include_count, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_usergroupsEnable(_api::UsergroupsApi, usergroup::String; include_count=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/usergroups.enable", ["slackAuth"])
    Swagger.set_param(_ctx.form, "include_count", include_count)  # type Bool
    Swagger.set_param(_ctx.form, "usergroup", usergroup)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Enable a User Group
Param: usergroup::String (required)
Param: include_count::Bool
Return: Dict{String, Any}
"""
function usergroupsEnable(_api::UsergroupsApi, usergroup::String; include_count=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsEnable(_api, usergroup; include_count=include_count, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function usergroupsEnable(_api::UsergroupsApi, response_stream::Channel, usergroup::String; include_count=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsEnable(_api, usergroup; include_count=include_count, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_usergroupsList(_api::UsergroupsApi; include_users=nothing, include_count=nothing, include_disabled=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/usergroups.list", ["slackAuth"])
    Swagger.set_param(_ctx.query, "include_users", include_users)  # type Bool
    Swagger.set_param(_ctx.query, "include_count", include_count)  # type Bool
    Swagger.set_param(_ctx.query, "include_disabled", include_disabled)  # type Bool
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

List all User Groups for a team
Param: include_users::Bool
Param: include_count::Bool
Param: include_disabled::Bool
Return: Dict{String, Any}
"""
function usergroupsList(_api::UsergroupsApi; include_users=nothing, include_count=nothing, include_disabled=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsList(_api; include_users=include_users, include_count=include_count, include_disabled=include_disabled, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function usergroupsList(_api::UsergroupsApi, response_stream::Channel; include_users=nothing, include_count=nothing, include_disabled=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsList(_api; include_users=include_users, include_count=include_count, include_disabled=include_disabled, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_usergroupsUpdate(_api::UsergroupsApi, usergroup::String; handle=nothing, description=nothing, channels=nothing, include_count=nothing, name=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/usergroups.update", ["slackAuth"])
    Swagger.set_param(_ctx.form, "handle", handle)  # type String
    Swagger.set_param(_ctx.form, "description", description)  # type String
    Swagger.set_param(_ctx.form, "channels", channels)  # type String
    Swagger.set_param(_ctx.form, "include_count", include_count)  # type Bool
    Swagger.set_param(_ctx.form, "usergroup", usergroup)  # type String
    Swagger.set_param(_ctx.form, "name", name)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Update an existing User Group
Param: usergroup::String (required)
Param: handle::String
Param: description::String
Param: channels::String
Param: include_count::Bool
Param: name::String
Return: Dict{String, Any}
"""
function usergroupsUpdate(_api::UsergroupsApi, usergroup::String; handle=nothing, description=nothing, channels=nothing, include_count=nothing, name=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsUpdate(_api, usergroup; handle=handle, description=description, channels=channels, include_count=include_count, name=name, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function usergroupsUpdate(_api::UsergroupsApi, response_stream::Channel, usergroup::String; handle=nothing, description=nothing, channels=nothing, include_count=nothing, name=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsUpdate(_api, usergroup; handle=handle, description=description, channels=channels, include_count=include_count, name=name, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_usergroupsUsersList(_api::UsergroupsApi, usergroup::String; include_disabled=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Dict{String, Any}, "/usergroups.users.list", ["slackAuth"])
    Swagger.set_param(_ctx.query, "include_disabled", include_disabled)  # type Bool
    Swagger.set_param(_ctx.query, "usergroup", usergroup)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded"] : [_mediaType])
    return _ctx
end

"""

List all users in a User Group
Param: usergroup::String (required)
Param: include_disabled::Bool
Return: Dict{String, Any}
"""
function usergroupsUsersList(_api::UsergroupsApi, usergroup::String; include_disabled=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsUsersList(_api, usergroup; include_disabled=include_disabled, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function usergroupsUsersList(_api::UsergroupsApi, response_stream::Channel, usergroup::String; include_disabled=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsUsersList(_api, usergroup; include_disabled=include_disabled, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

function _swaggerinternal_usergroupsUsersUpdate(_api::UsergroupsApi, usergroup::String, users::String; include_count=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", Dict{String, Any}, "/usergroups.users.update", ["slackAuth"])
    Swagger.set_param(_ctx.form, "include_count", include_count)  # type Bool
    Swagger.set_param(_ctx.form, "usergroup", usergroup)  # type String
    Swagger.set_param(_ctx.form, "users", users)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/x-www-form-urlencoded", "application/json"] : [_mediaType])
    return _ctx
end

"""

Update the list of users for a User Group
Param: usergroup::String (required)
Param: users::String (required)
Param: include_count::Bool
Return: Dict{String, Any}
"""
function usergroupsUsersUpdate(_api::UsergroupsApi, usergroup::String, users::String; include_count=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsUsersUpdate(_api, usergroup, users; include_count=include_count, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function usergroupsUsersUpdate(_api::UsergroupsApi, response_stream::Channel, usergroup::String, users::String; include_count=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_usergroupsUsersUpdate(_api, usergroup, users; include_count=include_count, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

export usergroupsCreate, usergroupsDisable, usergroupsEnable, usergroupsList, usergroupsUpdate, usergroupsUsersList, usergroupsUsersUpdate
